Index: main/channel.c
===================================================================
--- main/channel.c	(revision 356151)
+++ main/channel.c	(working copy)
@@ -2926,7 +2926,7 @@
 int ast_activate_generator(struct ast_channel *chan, struct ast_generator *gen, void *params)
 {
 	int res = 0;
-	void *generatordata;
+	void *generatordata = NULL;
 
 	ast_channel_lock(chan);
 	if (ast_channel_generatordata(chan)) {
@@ -2937,10 +2937,12 @@
 	if (gen->alloc && !(generatordata = gen->alloc(chan, params))) {
 		res = -1;
 	}
+	if (generatordata) {
+		ast_channel_generator_set(chan, gen);
+	}
 	if (!res) {
 		ast_settimeout(chan, 50, generator_force, chan);
 		ast_channel_generatordata_set(chan, generatordata);
-		ast_channel_generator_set(chan, gen);
 	}
 	ast_channel_unlock(chan);
 
Index: main/framehook.c
===================================================================
--- main/framehook.c	(revision 356151)
+++ main/framehook.c	(working copy)
@@ -104,12 +104,14 @@
 	framehook->chan = chan;
 
 	/* create the framehook list if it didn't already exist */
-	if (!ast_channel_framehooks(chan) && !(fh_list = ast_calloc(1, sizeof(*ast_channel_framehooks(chan))))) {
-		ast_free(framehook);
-		return -1;
+	if (!ast_channel_framehooks(chan)) {
+		if (!(fh_list = ast_calloc(1, sizeof(*ast_channel_framehooks(chan))))) {
+			ast_free(framehook);
+			return -1;
+		}
+		ast_channel_framehooks_set(chan, fh_list);
 	}
 
-	ast_channel_framehooks_set(chan, fh_list);
 	framehook->id = ++ast_channel_framehooks(chan)->id_count;
 	AST_LIST_INSERT_TAIL(&ast_channel_framehooks(chan)->list, framehook, list);
 
Index: res/res_monitor.c
===================================================================
--- res/res_monitor.c	(revision 356151)
+++ res/res_monitor.c	(working copy)
@@ -689,11 +689,13 @@
 		snprintf(tmp, sizeof(tmp), "%s/%s.%s", urlprefix, args.fname_base,
 			((strcmp(args.format, "gsm")) ? "wav" : "gsm"));
 		ast_channel_lock(chan);
-		if (!ast_channel_cdr(chan) && !(chan_cdr = ast_cdr_alloc())) {
-			ast_channel_unlock(chan);
-			return -1;
+		if (!ast_channel_cdr(chan)) {
+			if (!(chan_cdr = ast_cdr_alloc())) {
+				ast_channel_unlock(chan);
+				return -1;
+			}
+			ast_channel_cdr_set(chan, chan_cdr);
 		}
-		ast_channel_cdr_set(chan, chan_cdr);
 		ast_cdr_setuserfield(chan, tmp);
 		ast_channel_unlock(chan);
 	}
